## cantata 3.3.1.ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5...3.29)

project(
    Cantata
    VERSION "3.3.1"
    DESCRIPTION "Graphical MPD Client with Qt."
    HOMEPAGE_URL "https://github.com/nullobsi/cantata"
    LANGUAGES CXX C
)

#  NOTE: If PROJECT_URL, or PROJECT_REV_URL, are changed, then cantata-dynamic, README, and
#        dbus/mpd.cantata.xml will need renaming/updating.
set(PROJECT_ID "Cantata.cantata.unix.dog")
set(PROJECT_REV_ID "dog.unix.cantata.Cantata")
set(EXECUTABLE_NAME "cantata")

message(STATUS "Configuring ${PROJECT_NAME} v${PROJECT_VERSION}")

# Set module path.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Set CPack variables. Version info & name were given by the project
# command.
set(CPACK_PACKAGE_VENDOR ${PROJECT_NAME})
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README")
set(CPACK_PACKAGE_EXECUTABLES "${EXECUTABLE_NAME};${PROJECT_NAME}")

# TODO: CPACK_PACKAGE_DESCRIPTION & etc for installers

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")

set(CPACK_SOURCE_IGNORE_FILES
    "/.svn/;/.git/;.gitignore;.github/;.project;CMakeLists.txt.user;README.md;/screenshots/"
)

# Now set some variables used in config.h.

set(ORGANIZATION_NAME ${PROJECT_NAME})

# Install dirs
include(GNUInstallDirs)

# Packaging variables.
if(WIN32)
    set(ICON_INSTALL_PREFIX icons)

    # CPack.
    set(CPACK_GENERATOR WIX ZIP)

    # WIX .msi generator
    set(CPACK_WIX_PRODUCT_ICON "${CMAKE_SOURCE_DIR}/windows/cantata.ico")
    set(CPACK_WIX_PROPERTY_APPHELPLINK "${PROJECT_HOMEPAGE_URL}")
    set(CPACK_WIX_PROPERTY_APPURLINFOABOUT "${PROJECT_HOMEPAGE_URL}")
    set(CPACK_WIX_ROOT_FEATURE_DESCRIPTION "${PROJECT_DESCRIPTION}")

    set(CPACK_WIX_UPGRADE_GUID "5a353104-c90b-4467-a48c-2204681a5383")

    # WiX doesn't like files without extensions.
    configure_file(
        "${CMAKE_SOURCE_DIR}/LICENSE"
        "${CMAKE_BINARY_DIR}/LICENSE.txt"
        COPYONLY
    )
    configure_file(
        "${CMAKE_SOURCE_DIR}/README"
        "${CMAKE_BINARY_DIR}/README.txt"
        COPYONLY
    )

    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_BINARY_DIR}/LICENSE.txt")
    set(CPACK_RESOURCE_FILE_README "${CMAKE_BINARY_DIR}/README.txt")
elseif(APPLE)
    # CPack.
    set(CPACK_GENERATOR "DragNDrop")

    # Set default properties for target.
    set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
    set(MACOSX_BUNDLE_VERSION ${PROJECT_VERSION})
    set(MACOSX_BUNDLE_COPYRIGHT "Copyright © 2024 Cantata Contributors.")
    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${PROJECT_ID})
    set(MACOSX_BUNDLE_EXECUTABLE cantata)
    set(MACOSX_BUNDLE_ICON_FILE cantata.icns)
    set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})

    # Bundle installation shenanigans.
    set(APPS "\${CMAKE_INSTALL_PREFIX}/${MACOSX_BUNDLE_BUNDLE_NAME}.app")
    set(DIRS ${CMAKE_BINARY_DIR})

    # Extra variables used to install plugins and resources
    set(APP_BUNDLE_DIR ${PROJECT_NAME}.app)
    set(APP_CONTENTS_DIR ${APP_BUNDLE_DIR}/Contents)
    set(APP_RESOURCES_DIR ${APP_CONTENTS_DIR}/Resources)
    set(APP_MACOS_DIR ${APP_CONTENTS_DIR}/MacOS)
    set(ICON_INSTALL_PREFIX ${APP_RESOURCES_DIR}/icons/cantata)

    set(CPACK_PACKAGE_EXECUTABLES "${APP_BUNDLE_DIR};Cantata")
elseif(NOT HAIKU)
    set(ICON_INSTALL_PREFIX ${CMAKE_INSTALL_DATADIR}/icons/hicolor)

    set(CPACK_GENERATOR TGZ)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
    set(OPENBSD TRUE)
endif()

set(QT_MIN_VERSION 5.15)

include(CPack)
include(MacroLogFeature)

# Optional feature flags.
option(
    ENABLE_TAGLIB
    "Enable TagLib library (required for tag editing, replaygain calculation, device support, etc)"
    ON
)
option(
    ENABLE_HTTP_STREAM_PLAYBACK
    "Enable playback of MPD HTTP streams (LibVLC or QtMultimedia)"
    ON
)
option(
    ENABLE_FFMPEG
    "Enable ffmpeg/libav libraries (required for replaygain calculation)"
    ON
)
option(
    ENABLE_MPG123
    "Enable mpg123 libraries (required for replaygain calculation)"
    ON
)
option(ENABLE_PROXY_CONFIG "Enable proxy config in settings dialog" ON)
option(
    ENABLE_HTTP_SERVER
    "Enable internal HTTP server to play non-MPD files"
    ON
)
option(
    ENABLE_LIBVLC
    "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)"
    OFF
)
option(ENABLE_CATEGORIZED_VIEW "Enable support for categorised view" OFF)
option(ENABLE_SCROBBLING "Enable scrobbling" ON)

if(WIN32 OR APPLE OR HAIKU)
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
else()
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" ON)
    option(
        ENABLE_REMOTE_DEVICES
        "Enable support for remote (sshfs, samba) devices"
        ON
    )
    option(
        ENABLE_SIMPLE_MPD_SUPPORT
        "Enable support for simple (Cantata controlled) MPD"
        ON
    )
    if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
        option(ENABLE_UDISKS2 "Build UDisks2 backend, and NOT UDisks" ON)
    else()
        option(ENABLE_UDISKS2 "Build UDisks2 backend, and NOT UDisks" OFF)
    endif()
endif()
option(
    ENABLE_CDPARANOIA
    "Enable CDParanoia libraries (this or libCDIO_paranoia required for AudioCD support)"
    ON
)
option(
    ENABLE_CDIOPARANOIA
    "Enable libCDIO_paranoia libraries (this or CDParanoia required for AudioCD support)"
    ON
)
option(
    ENABLE_CDDB
    "Enable CDDB libraries (either this or MusicBrianz required for AudioCD support)"
    ON
)
option(
    ENABLE_MUSICBRAINZ
    "Enable MusicBrainz libraries (either this or CDDB required for AudioCD support)"
    ON
)
option(ENABLE_MTP "Enable MTP library (required to support MTP devices)" ON)
option(ENABLE_AVAHI "Enable automatic mpd server discovery" ${UNIX})

# Build all apps into top-level folder, so that can run dev versions without install
if(NOT WIN32 AND NOT APPLE)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
endif()

set(CMAKE_AUTOMOC TRUE)
set(CMAKE_AUTOUIC TRUE)
set(CMAKE_AUTORCC TRUE)

add_executable(cantata)

set_property(TARGET cantata PROPERTY CXX_STANDARD 17)
set_property(TARGET cantata PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET cantata PROPERTY COMPILE_WARNING_AS_ERROR ON)
target_compile_options(
    cantata
    PRIVATE
        $<$<CXX_COMPILER_ID:MSVC>:/W4>
        $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wall
        -Wextra
        -Wpedantic>
)
#    -Wno-cast-qual -Wno-float-equal -Wno-gnu-zero-variadic-macro-arguments \

if(ENABLE_AVAHI)
    find_package(Avahi)
    macro_log_feature(Avahi_FOUND "Avahi Support" "Automatic MPD-Server Detection" "https://www.avahi.org/" FALSE "" "")
endif()

if(Avahi_FOUND)
    target_sources(
        cantata
        PRIVATE gui/findmpddialog.cpp gui/avahidiscovery.cpp gui/avahipoll.cpp
    )
    target_link_libraries(cantata PRIVATE Avahi::Client)
endif()

if(NOT WIN32 AND NOT APPLE AND ENABLE_DEVICES_SUPPORT AND ENABLE_UDISKS2)
    set(WITH_SOLID_UDISKS2 ON)
endif()

if(ENABLE_TAGLIB)
    if(NOT TagLib_FOUND)
        find_package(TagLib 2.0 QUIET)
    endif()
    macro_log_feature(TagLib_FOUND "TagLib"     "Tag editor, file organiser, etc."     "http://taglib.github.io/")
endif()

if(TagLib_FOUND)
    if(ENABLE_DEVICES_SUPPORT AND (ENABLE_CDIOPARANOIA OR ENABLE_CDPARANOIA))
        # Issue 1021 - prefer libcdio_paranoia over plain cdparanoia
        if(ENABLE_CDIOPARANOIA)
            find_package(LibCDIOParanoia)
            macro_log_feature(LibCDIOParanoia_FOUND "libcdio_paranoia" "CD ripping." "https://www.gnu.org/software/libcdio/")
        endif()
        if(NOT LibCDIOParanoia_FOUND)
            find_package(CDParanoia)
            macro_log_feature(CDParanoia_FOUND "libcdda_paranoia" "CD ripping." "http://www.xiph.org/paranoia")
        endif()
        if(LibCDIOParanoia_FOUND OR CDParanoia_FOUND)
            if(ENABLE_CDDB)
                find_package(CDDB)
                macro_log_feature(CDDB_FOUND "libcddb" "CD info retrieval via CDDB." "http://libcddb.sourceforge.net")
            endif()
            if(ENABLE_MUSICBRAINZ)
                find_package(MusicBrainz5)
                macro_log_feature(MusicBrainz5_FOUND "libmusicbrainz5" "CD info retrieval via MusicBrainz." "http://musicbrainz.org/doc/libmusicbrainz")
            endif()
        endif()
    endif()

    set(ENABLE_TAGEDITOR_SUPPORT 1)
    set(ENABLE_TRACKORGANIZER_SUPPORT 1)

    if(ENABLE_FFMPEG)
        find_package(FFMPEG COMPONENTS avcodec avutil avformat)
        macro_log_feature(FFMPEG_FOUND "libavcodec/libavutil/libavformat" "ReplayGain calculation." "http://ffmpeg.org")
    endif()
    if(ENABLE_MPG123)
        find_package(MPG123)
        macro_log_feature(MPG123_FOUND "libmpg123" "ReplayGain calculation." "http://www.mpg123.de")
    endif()
    if(ENABLE_MTP AND ENABLE_DEVICES_SUPPORT AND NOT WIN32 AND NOT APPLE)
        find_package(MTP)
        macro_log_feature(MTP_FOUND "libmtp" "MTP Device Support." "http://libmtp.sourceforge.net")
    endif()
else(TagLib_FOUND)
    set(ENABLE_DEVICES_SUPPORT OFF)
endif()

set(QT_COMPONENTS
    Widgets
    Xml
    Network
    Concurrent
    Svg
    Sql
)

find_package(QT NAMES Qt6 REQUIRED COMPONENTS ${QT_COMPONENTS})
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS ${QT_COMPONENTS})

if(APPLE OR WIN32 OR HAIKU)
    get_target_property(
        QT_QMAKE_EXECUTABLE
        Qt${QT_VERSION_MAJOR}::qmake
        IMPORTED_LOCATION
    )
    execute_process(
        COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_TRANSLATIONS
        OUTPUT_VARIABLE QT_TRANSLATIONS_DIR
    )

    # Find deployment helpers.
    get_filename_component(QT_BIN_DIR "${QT_QMAKE_EXECUTABLE}" DIRECTORY)
    if(APPLE)
        find_program(
            MACDEPLOYQT_EXECUTABLE
            "macdeployqt${QT_VERSION_MAJOR}"
            HINTS "${QT_BIN_DIR}"
        )
    endif()
    if(WIN32)
        find_program(
            WINDEPLOYQT_EXECUTABLE
            "windeployqt${QT_VERSION_MAJOR}.exe"
            HINTS "${QT_BIN_DIR}"
        )
    endif()
else()
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
    set(QT_QTDBUS_FOUND 1) # required for config.h !!!
    list(APPEND QT_COMPONENTS DBus)
endif()

if(ENABLE_HTTP_STREAM_PLAYBACK)
    if(ENABLE_LIBVLC)
        # TODO: VLC as an imported target.
        find_package(LIBVLC REQUIRED)
        macro_log_feature(LIBVLC_FOUND "libVLC" "MPD HTTP stream playback." "http://videolan.org")
        target_compile_definitions(cantata PRIVATE LIBVLC_FOUND)
        target_include_directories(cantata PRIVATE ${LIBVLC_INCLUDE_DIR})
        target_link_libraries(cantata PRIVATE ${LIBVLC_LIBRARY})
    else()
        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Multimedia)
        macro_log_feature(Qt${QT_VERSION_MAJOR}Multimedia_FOUND "QtMultimedia" "MPD HTTP stream playback." "http://qtproject.org")
        list(APPEND QT_COMPONENTS Multimedia)
    endif()
    target_sources(cantata PRIVATE mpd-interface/httpstream.cpp)
endif()

find_package(ZLIB REQUIRED)

if(APPLE)
    target_sources(cantata PRIVATE mac/dockmenu.cpp)
    find_package(IOKit)
    if(IOKIT_FOUND)
        target_link_libraries(cantata PRIVATE ${IOKIT_LIBRARY})
        target_sources(cantata PRIVATE mac/powermanagement.cpp)
    endif()
    find_package(Foundation REQUIRED)
    find_library(MAC_APPKIT_LIBRARY AppKit REQUIRED)
    target_link_libraries(
        cantata
        PRIVATE ${FOUNDATION_LIBRARY} ${MAC_APPKIT_LIBRARY}
    )
    find_library(MAC_MEDIAPLAYER_LIBRARY MediaPlayer)
    if(MAC_MEDIAPLAYER_LIBRARY)
        target_sources(cantata PRIVATE mac/macnowplaying.mm)
        target_link_libraries(cantata PRIVATE ${MAC_MEDIAPLAYER_LIBRARY})
        target_compile_definitions(cantata PRIVATE MAC_MEDIAPLAYER_FOUND)
    endif()
elseif(WIN32 AND QT_VERSION_MAJOR EQUAL 5)
    find_package(Qt5 COMPONENTS WinExtras REQUIRED)
    list(APPEND QT_COMPONENTS WinExtras)

=== icons/CMakeLists.txt ===
if(NOT HAIKU AND NOT WIN32 AND NOT APPLE)
    install(
        FILES cantata.svg
        DESTINATION ${ICON_INSTALL_PREFIX}/scalable/apps
        RENAME ${PROJECT_REV_ID}.svg
    )
    install(
        FILES cantata-symbolic.svg
        DESTINATION ${ICON_INSTALL_PREFIX}/symbolic/apps
        RENAME ${PROJECT_REV_ID}-symbolic.svg
    )
    foreach(
        SIZE
        16
        22
        24
        32
        48
        64
        128
        256
        512
    )
        install(
            FILES cantata${SIZE}.png
            DESTINATION ${ICON_INSTALL_PREFIX}/${SIZE}x${SIZE}/apps
            RENAME ${PROJECT_REV_ID}.png
        )
    endforeach()

    #if (EXISTS /etc/lsb-release)
    #    file(READ "/etc/lsb-release" LSB_RELEASE_CONTENTS)
    #    string(REGEX MATCH "DISTRIB_ID=Ubuntu" IS_UBUNTU ${LSB_RELEASE_CONTENTS})
    #	if (IS_UBUNTU)
    #        set(INSTALL_UBUNTU_ICONS_DEFAULT ON)
    #    else(IS_UBUNTU)
    #        set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
    #    endif(IS_UBUNTU)
    #else(EXISTS /etc/lsb-release)
    set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
    #endif(EXISTS /etc/lsb-release)
    option(
        INSTALL_UBUNTU_ICONS
        "Install the Ubuntu Yaru icons"
        ${INSTALL_UBUNTU_ICONS_DEFAULT}
    )

    if(INSTALL_UBUNTU_ICONS)
        add_subdirectory(yaru)
        update_iconcache(Yaru)
    endif()
endif()

=== mac/CMakeLists.txt ===
install(FILES ${MACOSX_BUNDLE_ICON_FILE} DESTINATION ${APP_RESOURCES_DIR})

# Qt translation files...
file(GLOB qt_trans ${QT_TRANSLATIONS_DIR}/qt_*.qm)
foreach(qm ${qt_trans})
    if(NOT ${qm} MATCHES "(${QT_TRANSLATIONS_DIR}/qt_help*)")
        list(APPEND qt_translations "${qm}")
    endif(NOT ${qm} MATCHES "(${QT_TRANSLATIONS_DIR}/qt_help*)")
endforeach(qm ${qt_trans})
install(FILES ${qt_translations} DESTINATION ${APP_RESOURCE_DIR}/translations/)

=== replaygain/CMakeLists.txt ===
if(FFMPEG_FOUND OR MPG123_FOUND)
    add_executable(cantata-replaygain)
    target_link_libraries(
        cantata-replaygain
        PRIVATE
            Qt${QT_VERSION_MAJOR}::Core
            Qt${QT_VERSION_MAJOR}::Gui
            ZLIB::ZLIB
    )
    target_sources(
        cantata-replaygain
        PRIVATE
            main.cpp
            replaygain.cpp
            trackscanner.cpp
            jobcontroller.cpp
            ../support/thread.cpp
    )
    target_include_directories(
        cantata-replaygain
        PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
    )

    if(FFMPEG_FOUND)
        target_sources(cantata-replaygain PRIVATE ffmpeginput.cpp)
        target_link_libraries(
            cantata-replaygain
            PRIVATE FFMPEG::avutil FFMPEG::avcodec FFMPEG::avformat
        )
    endif()

    if(MPG123_FOUND)
        target_sources(cantata-replaygain PRIVATE mpg123input.cpp)
        target_link_libraries(cantata-replaygain PRIVATE MPG123::MPG123)
    endif()

    find_package(EBUR128)

    if(EBUR128_FOUND)
        message("-- Using system libebur128")
        target_link_libraries(cantata-replaygain PRIVATE EBUR128::EBUR128)
    else()
        message("-- Using supplied libebur128")
        add_subdirectory(
            ${CMAKE_SOURCE_DIR}/3rdparty/ebur128
            ${CMAKE_BINARY_DIR}/3rdparty/ebur128
        )
        target_link_libraries(cantata-replaygain PRIVATE ebur128)
    endif()

    if(UNIX AND NOT APPLE)
        target_link_libraries(cantata-replaygain PRIVATE pthread)
    endif()

    if(WIN32)
        set_property(TARGET cantata-replaygain PROPERTY WIN32_EXECUTABLE true)
        # Install to root of prefix.
        install(TARGETS cantata-replaygain RUNTIME DESTINATION ".")
    elseif(APPLE)
        install(TARGETS cantata-replaygain RUNTIME DESTINATION ${APP_MACOS_DIR})
    else()
        install(
            TARGETS cantata-replaygain
            RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/${PROJECT_NAME}
        )
    endif()
endif()

=== support/CMakeLists.txt ===
set(SUPPORT_CORE_SRCS utils.cpp thread.cpp)

add_library(support-core STATIC ${SUPPORT_CORE_SRCS})
target_include_directories(
    support-core
    PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
)
target_link_libraries(support-core PRIVATE ${QT_LIBS})

set(SUPPORT_SRCS
    icon.cpp
    fancytabwidget.cpp
    messagewidget.cpp
    buddylabel.cpp
    action.cpp
    actioncollection.cpp
    lineedit.cpp
    configuration.cpp
    gtkstyle.cpp
    spinner.cpp
    messagebox.cpp
    inputdialog.cpp
    thread.cpp
    squeezedtextlabel.cpp
    proxystyle.cpp
    pagewidget.cpp
    combobox.cpp
    configdialog.cpp
        QtAwesome.cpp
    QtAwesomeAnim.cpp
)

if(APPLE)
    set(SUPPORT_SRCS
        ${SUPPORT_SRCS}
        osxstyle.cpp
        flattoolbutton.cpp
        windowmanager.cpp
    )
endif()

set(SUPPORT_SRCS
    ${SUPPORT_SRCS}
    pathrequester.cpp
    kmessagewidget.cpp
    dialog.cpp
    shortcutsmodel.cpp
    shortcutssettingswidget.cpp
    keysequencewidget.cpp
    acceleratormanager.cpp
    urllabel.cpp
)
set(SUPPORT_UIS shortcutssettingswidget.ui)

qt_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
qt_add_resources(SUPPORT_RC_SRCS QtAwesomeFree.qrc)

add_library(
    support
    STATIC
    ${SUPPORT_SRCS}
    ${SUPPORT_UI_HDRS}
    ${SUPPORT_RC_SRCS}
)
target_link_libraries(support PRIVATE ${QT_LIBS})
target_include_directories(
    support
    PRIVATE
        ${CMAKE_SOURCE_DIR}
        ${CMAKE_BINARY_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
)

=== tags/CMakeLists.txt ===
add_executable(cantata-tags)
target_sources(
    cantata-tags
    PRIVATE
        main.cpp
        taghelper.cpp
        tags.cpp
        filetyperesolver.cpp
        ../mpd-interface/song.cpp
)
target_include_directories(
    cantata-tags
    PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
)

if(WIN32)
    set_property(TARGET cantata-tags PROPERTY WIN32_EXECUTABLE true)
    # Install to root of prefix.
    install(TARGETS cantata-tags RUNTIME DESTINATION ".")
elseif(APPLE)
    install(TARGETS cantata-tags RUNTIME DESTINATION ${APP_MACOS_DIR})
else()
    install(
        TARGETS cantata-tags
        RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/${PROJECT_NAME}
    )
endif()

# TODO: Find out where this is used to replace it.
add_definitions(-DCANTATA_TAG_SERVER -DCANTATA_NO_UI_FUNCTIONS)
target_link_libraries(
    cantata-tags
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Network
    TagLib::TagLib
)

=== translations/CMakeLists.txt ===
file(GLOB TS_FILES cantata_*.ts)

find_package(Qt${QT_VERSION_MAJOR}LinguistTools ${QT_MIN_VERSION} QUIET)

if(Qt${QT_VERSION_MAJOR}LinguistTools_FOUND)
    set(catalogname cantata)
    qt_add_lrelease(
            TS_FILES ${TS_FILES}
            LRELEASE_TARGET translations
            QM_FILES_OUTPUT_VARIABLE QM_FILES
    )
    if(WIN32)
        install(FILES ${QM_FILES} DESTINATION translations/)
    elseif(APPLE)
        install(
            FILES ${QM_FILES}
            DESTINATION ${APP_RESOURCES_DIR}/translations/
        )
    else()
        install(
            FILES ${QM_FILES}
            DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/translations/
        )
    endif()
    add_dependencies(cantata translations)
else()
    message(
        "------\n"
        "NOTE: lrelease not found. Translations will *not* be installed\n"
        "------\n"
    )
endif()

=== 3rdparty/kcategorizedview/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(KCAT_SOURCES
    kcategorizedsortfilterproxymodel.cpp
    kcategorizedview.cpp
    kcategorydrawer.cpp
)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${QTINCLUDES}
)

add_definitions(-DKITEMVIEWS_NO_DEPRECATED)

add_library(kcategorizedview STATIC ${KCAT_SOURCES})

=== 3rdparty/knotifications/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# ECM setup
include(FeatureSummary)

include(GenerateExportHeader)

set(REQUIRED_QT_VERSION 6.5.0)
set(CMAKE_AUTORCC TRUE)
set(CMAKE_AUTOMOC TRUE)

find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Gui)


if (NOT WIN32 AND NOT APPLE)
    find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED DBus)
endif()

find_package(Qt6 ${REQUIRED_QT_VERSION} QUIET OPTIONAL_COMPONENTS Qml)

if (WIN32)
    find_package(LibSnoreToast)
    find_package(Qt6Network REQUIRED)
    
    include(CMakeDependentOption)
    cmake_dependent_option(WITH_SNORETOAST "for the Windows Toast Notifications" ON
                           "Qt6Network_FOUND;LibSnoreToast_FOUND" OFF
    )    
endif()

if (NOT APPLE AND NOT WIN32 OR (WIN32 AND NOT WITH_SNORETOAST))
    find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED DBus)
endif()

set(HAVE_DBUS FALSE)
if (TARGET Qt6::DBus)
    set(HAVE_DBUS TRUE)
endif()

remove_definitions(-DQT_NO_CAST_FROM_BYTEARRAY)

add_subdirectory(src)

=== 3rdparty/qtiocompressor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_library(qtiocompressor STATIC qtiocompressor.cpp)
target_link_libraries(
    qtiocompressor
    PUBLIC Qt${QT_VERSION_MAJOR}::Core ZLIB::ZLIB
)

=== 3rdparty/solid-lite/CMakeLists.txt ===
include(MacroOptionalFindPackage)
include(MacroLogFeature)

add_library(solidlite STATIC)
add_subdirectory(ifaces)
target_include_directories(
    solidlite
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_SOURCE_DIR}/3rdparty
)

file(
    MAKE_DIRECTORY
    ${CMAKE_CURRENT_BINARY_DIR}/backends/hal
    ${CMAKE_CURRENT_BINARY_DIR}/backends/udev
    ${CMAKE_CURRENT_BINARY_DIR}/backends/wmi
)

target_sources(
    solidlite
    PRIVATE
        solidnamespace.cpp
        managerbase.cpp
        device.cpp
        devicemanager.cpp
        deviceinterface.cpp
        genericinterface.cpp
        block.cpp
        storagedrive.cpp
        opticaldrive.cpp
        storagevolume.cpp
        opticaldisc.cpp
        storageaccess.cpp
        portablemediaplayer.cpp
        predicate.cpp
        predicateparse.cpp
        predicate_lexer.c
        predicate_parser.c
        xdgbasedirs.cpp
        ifaces/block.cpp
        ifaces/opticaldrive.cpp
        ifaces/device.cpp
        ifaces/deviceinterface.cpp
        ifaces/devicemanager.cpp
        ifaces/genericinterface.cpp
        ifaces/opticaldisc.cpp
        ifaces/portablemediaplayer.cpp
        ifaces/storagedrive.cpp
        ifaces/storagevolume.cpp
        ifaces/storageaccess.cpp
        backends/shared/rootdevice.cpp
)

if(NOT WIN32 AND NOT APPLE AND WITH_SOLID_UDISKS2)
    find_package(UDev REQUIRED)
    macro_log_feature( UDev_FOUND "UDev" "UDev support for Solid" "http://www.kernel.org/pub/linux/utils/kernel/hotplug/udev.html" FALSE "" "Allows Solid to use UDev to provide information about devices on Linux")
endif()
configure_file(config-solid.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-solid.h)

if(UDev_FOUND)
    message(STATUS "Building Solid UDev backend.")
    target_sources(
        solidlite
        PRIVATE
            backends/udev/udevdevice.cpp
            backends/udev/udevmanager.cpp
            backends/udev/udevdeviceinterface.cpp
            backends/udev/udevgenericinterface.cpp
            backends/udev/udevportablemediaplayer.cpp
            backends/udev/udevblock.cpp
            backends/shared/udevqtclient.cpp
            backends/shared/udevqtdevice.cpp
    )

    # check for media-player-info (runtime-only optional dependency)
    set(XDG_DATA_DIRS_ENV $ENV{XDG_DATA_DIRS}) # if(ENV{..}) does not work for me
    if(XDG_DATA_DIRS_ENV)
        find_path(
            MEDIAPLAYERINFO_PATH
            sony_psp.mpi
            PATHS
            ENV XDG_DATA_DIRS
            PATH_SUFFIXES "media-player-info"
            NO_DEFAULT_PATH
        )
    else()
        set(XDG_DATA_DIRS "/usr/share")
        message(
            STATUS
            "Warning: environment variable XDG_DATA_DIRS not set, falling back to ${XDG_DATA_DIRS}"
        )
        find_path(
            MEDIAPLAYERINFO_PATH
            sony_psp.mpi
            PATHS "${XDG_DATA_DIRS}"
            PATH_SUFFIXES "media-player-info"
            NO_DEFAULT_PATH
        )
    endif()

    macro_log_feature(MEDIAPLAYERINFO_PATH
         "media-player-info"
         "Enables identification and querying of portable media players"
         "http://www.freedesktop.org/wiki/Software/media-player-info"
         FALSE
         ""
         "Runtime-only dependency of the udev solid backend. Support for m-p-i is included even if not found during build"
    )
endif()

message(STATUS "Building Solid HAL backend.")
target_sources(
    solidlite
    PRIVATE
        backends/hal/halblock.cpp
        backends/hal/halcdrom.cpp
        backends/hal/haldeviceinterface.cpp
        backends/hal/halfstabhandling.cpp
        backends/hal/halgenericinterface.cpp
        backends/hal/haldevice.cpp
        backends/hal/halmanager.cpp
        backends/hal/halopticaldisc.cpp
        backends/hal/halportablemediaplayer.cpp
        backends/hal/halstorageaccess.cpp
        backends/hal/halstorage.cpp
        backends/hal/halvolume.cpp
)

# FIXME: this should work on more Unix systems
if(CMAKE_SYSTEM_NAME MATCHES Linux)
    if(WITH_SOLID_UDISKS2)
        message(STATUS "Building Solid UDisks2 backend.")
        add_definitions(-DWITH_SOLID_UDISKS2)
        target_sources(
            solidlite
            PRIVATE
                backends/udisks2/udisksmanager.cpp
                backends/udisks2/udisksdevice.cpp
                backends/udisks2/udisksdevicebackend.cpp
                backends/udisks2/udisksblock.cpp
                backends/udisks2/udisksstoragevolume.cpp
                backends/udisks2/udisksdeviceinterface.cpp
                backends/udisks2/udisksopticaldisc.cpp
                backends/udisks2/udisksopticaldrive.cpp
                backends/udisks2/udisksstoragedrive.cpp
                backends/udisks2/udisksstorageaccess.cpp
                backends/udisks2/udisksgenericinterface.cpp
                backends/udisks2/dbus/manager.cpp
        )
        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus Xml)
        target_link_libraries(
            solidlite
            PRIVATE Qt${QT_VERSION_MAJOR}::DBus Qt${QT_VERSION_MAJOR}::Xml
        )
    else()
        message(STATUS "Building Solid UDisks backend.")
        target_sources(
            solidlite
            PRIVATE
                backends/udisks/udisksmanager.cpp
                backends/udisks/udisksdevice.cpp
                backends/udisks/udisksblock.cpp
                backends/udisks/udisksstoragevolume.cpp
                backends/udisks/udisksdeviceinterface.cpp
                backends/udisks/udisksopticaldisc.cpp
                backends/udisks/udisksopticaldrive.cpp
                backends/udisks/udisksstoragedrive.cpp
                backends/udisks/udisksstorageaccess.cpp
                backends/udisks/udisksgenericinterface.cpp
        )
    endif()
endif()

if(APPLE)
    find_package(IOKit REQUIRED)

    message(STATUS "-- Building Solid IOKit backend.")
    target_sources(
        solidlite
        PRIVATE
            backends/iokit/iokitmanager.cpp
            backends/iokit/iokitdevice.cpp
            backends/iokit/cfhelper.cpp
            backends/iokit/iokitdeviceinterface.cpp
            backends/iokit/iokitgenericinterface.cpp
    )
endif(APPLE)

if(WIN32)
    include(CheckIncludeFileCXX)
    check_include_file_cxx(wbemidl.h HAVE_WBEM)
    find_library(WBEM_LIBRARIES NAMES wbemuuid wbemuuidd)
    if(HAVE_WBEM AND WBEM_LIBRARIES)
        set(HAVE_WBEM True)
        message(STATUS "Found wbemuuid library: ${WBEM_LIBRARIES}")
    else()
        set(HAVE_WBEM False)
    endif()
    if(HAVE_WBEM AND NOT WINCE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_WBEM")
        message(STATUS "-- Building Solid WMI backend.")

        target_sources(
            solidlite
            PRIVATE
                backends/wmi/wmiblock.cpp
                backends/wmi/wmicdrom.cpp
                backends/wmi/wmideviceinterface.cpp
                backends/wmi/wmigenericinterface.cpp
                backends/wmi/wmidevice.cpp
                backends/wmi/wmimanager.cpp
                backends/wmi/wmiopticaldisc.cpp
                backends/wmi/wmiportablemediaplayer.cpp
                backends/wmi/wmiquery.cpp
                backends/wmi/wmistorageaccess.cpp
                backends/wmi/wmistorage.cpp
                backends/wmi/wmivolume.cpp
        )
    endif()
endif()

set(solidlite_OPTIONAL_LIBS)

if(WIN32)
    set(solidlite_OPTIONAL_LIBS ${solidlite_OPTIONAL_LIBS} ${KDEWIN_LIBRARY})
    if(HAVE_WBEM)
        set(solidlite_OPTIONAL_LIBS
            ${solidlite_OPTIONAL_LIBS}
            ${WBEM_LIBRARIES}
        )
    endif()
endif()

if(APPLE)
    set(solidlite_OPTIONAL_LIBS ${IOKIT_LIBRARY})
endif()

if(UDev_FOUND)
    set(solidlite_OPTIONAL_LIBS ${solidlite_OPTIONAL_LIBS} UDev::UDev)
endif()

target_link_libraries(
    solidlite
    PRIVATE
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Widgets
        ${solidlite_OPTIONAL_LIBS}
)

if(WINCE)
    target_link_libraries(solidlite ${WCECOMPAT_LIBRARIES})
endif()

# set_target_properties(solidlite PROPERTIES
#    VERSION ${GENERIC_LIB_VERSION}
#    SOVERSION ${GENERIC_LIB_SOVERSION}
# )

#set(lexer_FILE predicate_lexer)
#set(parser_FILE predicate_parser)

#find_package(Flex)
#macro_log_feature(FLEX_FOUND
#   "Flex"
#   "Allows the Solid predicate parser to be updated"
#   "http://flex.sourceforge.net"
#   FALSE
#   ""
#   "Required by the UpdateSolidPredicateParser target (mainly useful for developers)")

#find_program(BISON_EXECUTABLE bison)
#macro_log_feature(BISON_EXECUTABLE
#   "Bison"
#   "Allows the Solid predicate parser to be updated"
#   "http://www.gnu.org/software/bison"
#   FALSE
#   ""
#   "Required by the UpdateSolidPredicateParser target (mainly useful for developers)")
#mark_as_advanced(BISON_EXECUTABLE)      # don't show it in the simple view in cmake-gui/ccmake

# if (FLEX_EXECUTABLE AND BISON_EXECUTABLE)
#
#    add_custom_target(UpdateSolidPredicateParser
#                      COMMAND ${FLEX_EXECUTABLE} -P Solid -o${lexer_FILE}.c ${lexer_FILE}.l
#                      COMMAND ${BISON_EXECUTABLE} -p Solid -d -b ${parser_FILE} ${parser_FILE}.y
#                      COMMAND ${CMAKE_COMMAND} -E copy ${parser_FILE}.tab.c ${CMAKE_CURRENT_SOURCE_DIR}/${parser_FILE}.c
#                      COMMAND ${CMAKE_COMMAND} -E copy ${parser_FILE}.tab.h ${CMAKE_CURRENT_SOURCE_DIR}/${parser_FILE}.h
#                      COMMAND ${CMAKE_COMMAND} -E remove ${parser_FILE}.tab.c ${parser_FILE}.tab.h
#                      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
#
# else (FLEX_EXECUTABLE AND BISON_EXECUTABLE)
#    add_custom_target(UpdateSolidPredicateParser
#                      COMMAND echo "flex and/or bison not found, so target UpdateSolidPredicateParser inactive")
# endif (FLEX_EXECUTABLE AND BISON_EXECUTABLE)

=== icons/yaru/CMakeLists.txt ===
set(CANTATA_SURU_ICON_INSTALL_PREFIX ${SHARE_INSTALL_PREFIX}/icons/Yaru)
install(
    FILES ../cantata-symbolic.svg
    DESTINATION ${CANTATA_SURU_ICON_INSTALL_PREFIX}/scalable/apps
)

foreach(
    SIZE
    16
    24
    32
    48
    256
)
    foreach(DPI "" @2x)
        install(
            FILES cantata-${SIZE}x${SIZE}${DPI}.png
            DESTINATION
                ${CANTATA_SURU_ICON_INSTALL_PREFIX}/${SIZE}x${SIZE}${DPI}/apps
            RENAME cantata.png
        )
    endforeach()
endforeach()

=== debian/changelog ===
cantata (3.3.1.ds1-1) unstable; urgency=medium

  * New upstream version.
    - use new upstream source at https://github.com/nullobsi/cantata
    - refresh patches, dropping those applied upstream
    - fixes FTBFS with CMake 4 (Closes: #1112761)
  * Update Standards-Version to 4.7.2 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Sun, 28 Sep 2025 11:24:19 +1000

cantata (2.5.0.ds1-4) unstable; urgency=medium

  * Add patch to fix FTBFS with taglib 2.0 (Closes: #1092685).

 -- Stuart Prescott <stuart@debian.org>  Sat, 11 Jan 2025 16:25:53 +1100

cantata (2.5.0.ds1-3) unstable; urgency=medium

  * Fix FTBFS with ffmpeg 7.0 with patch (Closes: #1072403).
  * Switch from pkg-config to pkgconf.
  * Update Standards-Version to 4.7.0 (no changes required).
  * Update copyright hints and regenerate.
  * Restore incorrectly deleted debian/source/lintian-overrides.

 -- Stuart Prescott <stuart@debian.org>  Mon, 03 Jun 2024 18:20:40 +1000

=== debian/control ===
Source: cantata
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Stuart Prescott <stuart@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libavahi-client-dev,
 libavahi-common-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libcddb2-dev,
 libcdio-paranoia-dev,
 libdbus-1-dev,
 libebur128-dev,
 libmpg123-dev,
 libmtp-dev,
 libmusicbrainz5-dev,
 qt6-svg-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libtag-dev,
 libudev-dev [linux-any],
 pkg-kde-tools,
 pkgconf,
 qt6-base-dev,
 qt6-multimedia-dev,
 qt6-tools-dev,
 qt6-base-dev-tools,
Standards-Version: 4.7.2
Homepage: https://github.com/nullobsi/cantata
Vcs-Browser: https://salsa.debian.org/multimedia-team/cantata
Vcs-Git: https://salsa.debian.org/multimedia-team/cantata.git
Rules-Requires-Root: no

Package: cantata
Architecture: any
Depends:
# fonts-font-awesome,
 libqt6sql6-sqlite,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libio-socket-ip-perl,
 liburi-perl,
Provides:
 mpd-client,
Suggests:
 media-player-info,
 mpd,
Description: Qt client for the music player daemon (MPD)
 Cantata is a graphical front-end for the music player daemon, MPD. It provides
 many tools to view and manage the music collection including:
 .
   * library - sorted by album, artist, track, directory
   * albums with cover art
   * user defined playlists
   * dynamic playlists
   * streams, internet radio
   * lyrics
   * artist information from Wikipedia
   * device support for USB mass storage, MTP and CDs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT=6

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf6

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_REMOTE_DEVICES=OFF

execute_after_dh_installexamples:
	chmod -x $(CURDIR)/debian/cantata/usr/share/doc/cantata/examples/cantata-dynamic.service

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/[.+]ds[0-9]//
Owner: nullobsi
Project: cantata
Repacksuffix: .ds1

## cantata 3.4.0.ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(
     Cantata
-    VERSION "3.3.1"
+    VERSION "3.4.0"
     DESCRIPTION "Graphical MPD Client with Qt."
     HOMEPAGE_URL "https://github.com/nullobsi/cantata"
     LANGUAGES CXX C
@@ -78,7 +78,7 @@
     set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
     set(MACOSX_BUNDLE_VERSION ${PROJECT_VERSION})
     set(MACOSX_BUNDLE_COPYRIGHT "Copyright © 2024 Cantata Contributors.")
-    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${PROJECT_ID})
+	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${PROJECT_REV_ID})
     set(MACOSX_BUNDLE_EXECUTABLE cantata)
     set(MACOSX_BUNDLE_ICON_FILE cantata.icns)
     set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
@@ -143,13 +143,18 @@
     "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)"
     OFF
 )
-option(ENABLE_CATEGORIZED_VIEW "Enable support for categorised view" OFF)
 option(ENABLE_SCROBBLING "Enable scrobbling" ON)
 
 if(WIN32 OR APPLE OR HAIKU)
     option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
+	option(BUNDLED_KCATEGORIZEDVIEW "Compile vendored KCategorizedView" ON)
+	option(BUNDLED_KARCHIVE "Compile vendored KArchive" ON)
+	option(BUNDLED_FONTAWESOME "Use bundled QResources for FontAwesome." ON)
 else()
     option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" ON)
+	option(BUNDLED_KCATEGORIZEDVIEW "Compile vendored KCategorizedView" OFF)
+	option(BUNDLED_KARCHIVE "Compile vendored KArchive" OFF)
+	option(BUNDLED_FONTAWESOME "Use bundled QResources for FontAwesome." OFF)
     option(
         ENABLE_REMOTE_DEVICES
         "Enable support for remote (sshfs, samba) devices"
@@ -344,23 +349,20 @@
 
 if(APPLE)
     target_sources(cantata PRIVATE mac/dockmenu.cpp)
+
     find_package(IOKit)
-    if(IOKIT_FOUND)
-        target_link_libraries(cantata PRIVATE ${IOKIT_LIBRARY})
+    if(IOKit_FOUND)
+        target_link_libraries(cantata PRIVATE IOKit::IOKit)
         target_sources(cantata PRIVATE mac/powermanagement.cpp)
     endif()
+
     find_package(Foundation REQUIRED)
-    find_library(MAC_APPKIT_LIBRARY AppKit REQUIRED)
+    find_package(AppKit REQUIRED)
     target_link_libraries(
         cantata
-        PRIVATE ${FOUNDATION_LIBRARY} ${MAC_APPKIT_LIBRARY}
-    )
-    find_library(MAC_MEDIAPLAYER_LIBRARY MediaPlayer)
-    if(MAC_MEDIAPLAYER_LIBRARY)
+        PRIVATE Foundation::Foundation AppKit::AppKit
+    )
+
+    find_package(MediaPlayer)
+    if(MediaPlayer_FOUND)
         target_sources(cantata PRIVATE mac/macnowplaying.mm)
-        target_link_libraries(cantata PRIVATE ${MAC_MEDIAPLAYER_LIBRARY})
-        target_compile_definitions(cantata PRIVATE MAC_MEDIAPLAYER_FOUND)
-    endif()
-elseif(WIN32 AND QT_VERSION_MAJOR EQUAL 5)
-    find_package(Qt5 COMPONENTS WinExtras REQUIRED)
-    list(APPEND QT_COMPONENTS WinExtras)

=== replaygain/CMakeLists.txt ===
--- 
+++ 
@@ -34,19 +34,8 @@
         target_link_libraries(cantata-replaygain PRIVATE MPG123::MPG123)
     endif()
 
-    find_package(EBUR128)
-
-    if(EBUR128_FOUND)
-        message("-- Using system libebur128")
-        target_link_libraries(cantata-replaygain PRIVATE EBUR128::EBUR128)
-    else()
-        message("-- Using supplied libebur128")
-        add_subdirectory(
-            ${CMAKE_SOURCE_DIR}/3rdparty/ebur128
-            ${CMAKE_BINARY_DIR}/3rdparty/ebur128
-        )
-        target_link_libraries(cantata-replaygain PRIVATE ebur128)
-    endif()
+	find_package(EBUR128 REQUIRED)
+	target_link_libraries(cantata-replaygain PRIVATE EBUR128::EBUR128)
 
     if(UNIX AND NOT APPLE)
         target_link_libraries(cantata-replaygain PRIVATE pthread)

=== support/CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,9 @@
 set(SUPPORT_UIS shortcutssettingswidget.ui)
 
 qt_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
-qt_add_resources(SUPPORT_RC_SRCS QtAwesomeFree.qrc)
+if (BUNDLED_FONTAWESOME)
+	qt_add_resources(SUPPORT_RC_SRCS QtAwesomeFree.qrc)
+endif()
 
 add_library(
     support

=== 3rdparty/kcategorizedview/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5...3.31)

set(KCAT_SOURCES
    kcategorizedsortfilterproxymodel.cpp
    kcategorizedview.cpp
    kcategorydrawer.cpp
)

add_definitions(-DKITEMVIEWS_NO_DEPRECATED)

add_library(kcategorizedview STATIC ${KCAT_SOURCES})
target_link_libraries(kcategorizedview PRIVATE Qt6::Widgets)

target_include_directories(
	kcategorizedview PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
)

=== 3rdparty/karchive/src/CMakeLists.txt ===
add_library(KF6Archive STATIC)
add_library(KF6::Archive ALIAS KF6Archive)

set_target_properties(KF6Archive PROPERTIES
    EXPORT_NAME "Archive"
)

target_sources(KF6Archive PRIVATE karchive.cpp
    kar.cpp
    kcompressiondevice.cpp
    kfilterbase.cpp
    kgzipfilter.cpp
    klimitediodevice.cpp
    knonefilter.cpp
    ktar.cpp
    kzip.cpp
    krcc.cpp
)

target_link_libraries(KF6Archive
    PUBLIC
        Qt6::Core
    PRIVATE
        ZLIB::ZLIB
)

target_include_directories(KF6Archive
	PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
)

=== debian/changelog ===
cantata (3.4.0.ds1-1) unstable; urgency=medium

  * New upstream release.
    - drop patches, merged upstream
    - add new build-dep on libkf6archive-dev, libkf6itemviews-dev

 -- Stuart Prescott <stuart@debian.org>  Sat, 24 Jan 2026 13:35:42 +1100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,8 @@
  libcdio-paranoia-dev,
  libdbus-1-dev,
  libebur128-dev,
+ libkf6archive-dev,
+ libkf6itemviews-dev,
  libmpg123-dev,
  libmtp-dev,
  libmusicbrainz5-dev,
